Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phystokenc.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/phystokenc.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phystokenc.F	(revision 633)
@@ -7,6 +7,7 @@
      I                   nlon,nlev,pdtphys,rlon,rlat,
      I                   pt,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+     I                   pfm_therm,pentr_therm,
      I                   pcoefh,yu1,yv1,ftsol,pctsrf,
-     I                   pfrac_impa,pfrac_nucl,
+     I                   frac_impa,frac_nucl,
      I                   pphis,paire,dtime,itap)
       USE ioipsl
@@ -40,5 +41,7 @@
       real pdtphys ! pas d'integration pour la physique (seconde)
 c
-      integer physid, itap,ndex(1)
+      integer physid, itap
+      save physid
+      integer ndex2d(iim*(jjm+1)),ndex3d(iim*(jjm+1)*klev)
 
 c   convection:
@@ -51,5 +54,5 @@
       REAL pen_d(klon,klev) ! flux entraine dans le panache descendant
       REAL pde_d(klon,klev) ! flux detraine dans le panache descendant
-	REAL pt(klon,klev)
+	real pt(klon,klev),t(klon,klev)
 c
       REAL rlon(klon), rlat(klon), dtime
@@ -62,10 +65,18 @@
       REAL yv1(klon)
       REAL yu1(klon),pphis(klon),paire(klon)
+
+c   Les Thermiques : (Abderr 25 11 02)
+c   ---------------
+      REAL pfm_therm(klon,klev+1)
+	real fm_therm1(klon,klev)
+      REAL pentr_therm(klon,klev)
+      REAL entr_therm(klon,klev)
+      REAL fm_therm(klon,klev)
 c
 c   Lessivage:
 c   ----------
 c
-      REAL pfrac_impa(klon,klev)
-      REAL pfrac_nucl(klon,klev)
+      REAL frac_impa(klon,klev)
+      REAL frac_nucl(klon,klev)
 c
 c Arguments necessaires pour les sources et puits de traceur
@@ -84,8 +95,4 @@
       REAL de_d(klon,klev) ! flux detraine dans le panache descendant
       REAL coefh(klon,klev) ! flux detraine dans le panache descendant
-	REAL t(klon,klev)
-      REAL frac_impa(klon,klev)
-      REAL frac_nucl(klon,klev)
-      REAL rain(klon)
 
       REAL pyu1(klon),pyv1(klon)
@@ -98,8 +105,9 @@
       integer iadvtr,irec
       real zmin,zmax
-
+      logical ok_sync
+ 
       save t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,dtcum
+	save fm_therm,entr_therm
       save iadvtr,irec
-      save frac_impa,frac_nucl,rain
       save pyu1,pyv1,pftsol,ppsrf
 
@@ -109,4 +117,6 @@
 c======================================================================
 
+      ok_sync = .true.
+	print*,'Dans phystokenc.F'
       print*,'iadvtr= ',iadvtr
       print*,'istphy= ',istphy
@@ -120,19 +130,19 @@
 	write(*,*) 'apres initphysto ds phystokenc' 
 
-       ndex(1) = 0
-         i=itap 
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
-         CALL histwrite(physid,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex)
-c
-         i=itap
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
-         CALL histwrite(physid,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex)
 	
       ENDIF
 c
+      ndex2d = 0
+      ndex3d = 0
+      i=itap 
+      CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
+      CALL histwrite(physid,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+c
+      i=itap
+      CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
+      CALL histwrite(physid,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+
       iadvtr=iadvtr+1
 c
-c
-c   reinitialisation des champs cumules
       if (mod(iadvtr,istphy).eq.1.or.istphy.eq.1) then
 	print*,'reinitialisation des champs cumules 
@@ -140,6 +150,4 @@
          do k=1,klev
             do i=1,klon
-               frac_impa(i,k)=1.
-               frac_nucl(i,k)=1.
                mfu(i,k)=0.
                mfd(i,k)=0.
@@ -149,9 +157,10 @@
                de_d(i,k)=0.
                coefh(i,k)=0.
-		t(i,k)=0.
-            enddo
-         enddo
-         do i=1,klon
-            rain(i)=0.
+                t(i,k)=0.
+		fm_therm(i,k)=0.
+               entr_therm(i,k)=0.
+            enddo
+         enddo
+         do i=1,klon
             pyv1(i)=0.
             pyu1(i)=0.
@@ -169,6 +178,217 @@
       do k=1,klev
          do i=1,klon
-            frac_impa(i,k)=frac_impa(i,k)*pfrac_impa(i,k)
-            frac_nucl(i,k)=frac_nucl(i,k)*pfrac_nucl(i,k)
+            mfu(i,k)=mfu(i,k)+pmfu(i,k)*pdtphys
+            mfd(i,k)=mfd(i,k)+pmfd(i,k)*pdtphys
+            en_u(i,k)=en_u(i,k)+pen_u(i,k)*pdtphys
+            de_u(i,k)=de_u(i,k)+pde_u(i,k)*pdtphys
+            en_d(i,k)=en_d(i,k)+pen_d(i,k)*pdtphys
+            de_d(i,k)=de_d(i,k)+pde_d(i,k)*pdtphys
+            coefh(i,k)=coefh(i,k)+pcoefh(i,k)*pdtphys
+                t(i,k)=t(i,k)+pt(i,k)*pdtphys
+       fm_therm(i,k)=fm_therm(i,k)+pfm_therm(i,k)*pdtphys
+       entr_therm(i,k)=entr_therm(i,k)+pentr_therm(i,k)*pdtphys
+         enddo
+      enddo
+         do i=1,klon
+            pyv1(i)=pyv1(i)+yv1(i)*pdtphys
+            pyu1(i)=pyu1(i)+yu1(i)*pdtphys
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=pftsol(i,k)+ftsol(i,k)*pdtphys
+               ppsrf(i,k)=ppsrf(i,k)+pctsrf(i,k)*pdtphys
+            enddo
+         enddo
+
+      dtcum=dtcum+pdtphys
+
+      IF(mod(iadvtr,istphy).eq.0) THEN 
+c
+c   normalisation par le temps cumule
+         do k=1,klev
+            do i=1,klon
+               mfu(i,k)=mfu(i,k)/dtcum
+               mfd(i,k)=mfd(i,k)/dtcum
+               en_u(i,k)=en_u(i,k)/dtcum
+               de_u(i,k)=de_u(i,k)/dtcum
+               en_d(i,k)=en_d(i,k)/dtcum
+               de_d(i,k)=de_d(i,k)/dtcum
+               coefh(i,k)=coefh(i,k)/dtcum
+c Unitel a enlever
+	      t(i,k)=t(i,k)/dtcum	
+               fm_therm(i,k)=fm_therm(i,k)/dtcum
+	       entr_therm(i,k)=entr_therm(i,k)/dtcum
+            enddo
+         enddo
+         do i=1,klon
+            pyv1(i)=pyv1(i)/dtcum
+            pyu1(i)=pyu1(i)/dtcum
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=pftsol(i,k)/dtcum
+               pftsol1(i) = pftsol(i,1)
+               pftsol2(i) = pftsol(i,2)
+               pftsol3(i) = pftsol(i,3)
+               pftsol4(i) = pftsol(i,4)
+
+               ppsrf(i,k)=ppsrf(i,k)/dtcum
+               ppsrf1(i) = ppsrf(i,1)
+               ppsrf2(i) = ppsrf(i,2)
+               ppsrf3(i) = ppsrf(i,3)
+               ppsrf4(i) = ppsrf(i,4)
+
+            enddo
+         enddo
+c
+c   ecriture des champs
+c
+         irec=irec+1
+
+ccccc
+         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
+         CALL histwrite(physid,"t",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+
+         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
+      CALL histwrite(physid,"mfu",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+	CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
+      CALL histwrite(physid,"mfd",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
+      CALL histwrite(physid,"en_u",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
+      CALL histwrite(physid,"de_u",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
+      CALL histwrite(physid,"en_d",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)       
+      CALL histwrite(physid,"de_d",itap,zx_tmp_3d,    
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)         
+      CALL histwrite(physid,"coefh",itap,zx_tmp_3d,    
+     .                                   iim*(jjm+1)*klev,ndex3d)	
+
+c ajou...
+	do k=1,klev
+           do i=1,klon
+	 fm_therm1(i,k)=fm_therm(i,k)	
+	   enddo
+	enddo
+
+      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, fm_therm1, zx_tmp_3d)
+      CALL histwrite(physid,"fm_th",itap,zx_tmp_3d,
+     .                                 iim*(jjm+1)*klev,ndex3d)
+c
+      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, entr_therm, zx_tmp_3d)
+      CALL histwrite(physid,"en_th",itap,zx_tmp_3d,
+     .                                iim*(jjm+1)*klev,ndex3d)
+cccc
+       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
+        CALL histwrite(physid,"frac_impa",itap,zx_tmp_3d,
+     .  iim*(jjm+1)*klev,ndex3d)
+
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
+        CALL histwrite(physid,"frac_nucl",itap,zx_tmp_3d,
+     .  iim*(jjm+1)*klev,ndex3d)
+ 
+        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
+      CALL histwrite(physid,"pyu1",itap,zx_tmp_2d,iim*(jjm+1),
+     .                                                ndex2d)
+	
+	CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
+      CALL histwrite(physid,"pyv1",itap,zx_tmp_2d,iim*(jjm+1)
+     .                                                ,ndex2d)
+	
+	CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol1",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol2",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol3",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol4",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
+      CALL histwrite(physid,"psrf1",itap,zx_tmp_2d,   
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
+      CALL histwrite(physid,"psrf2",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
+      CALL histwrite(physid,"psrf3",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
+      CALL histwrite(physid,"psrf4",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+
+      if (ok_sync) call histsync(physid)
+c     if (ok_sync) call histsync
+	
+c
+cAA Test sur la valeur des coefficients de lessivage 
+c
+         zmin=1e33
+         zmax=-1e33
+         do k=1,klev
+            do i=1,klon
+                  zmax=max(zmax,frac_nucl(i,k))
+                  zmin=min(zmin,frac_nucl(i,k))
+            enddo
+         enddo
+         Print*,'------ coefs de lessivage (min et max) --------'
+         Print*,'facteur de nucleation ',zmin,zmax
+         zmin=1e33
+         zmax=-1e33
+         do k=1,klev
+            do i=1,klon
+                  zmax=max(zmax,frac_impa(i,k))
+                  zmin=min(zmin,frac_impa(i,k))
+            enddo
+         enddo
+         Print*,'facteur d impaction ',zmin,zmax
+
+      ENDIF 
+
+c   reinitialisation des champs cumules
+	go to 768
+      if (mod(iadvtr,istphy).eq.1) then
+         do k=1,klev
+            do i=1,klon
+               mfu(i,k)=0.
+               mfd(i,k)=0.
+               en_u(i,k)=0.
+               de_u(i,k)=0.
+               en_d(i,k)=0.
+               de_d(i,k)=0.
+               coefh(i,k)=0.
+	       t(i,k)=0.
+               fm_therm(i,k)=0.
+	       entr_therm(i,k)=0.
+            enddo
+         enddo
+         do i=1,klon
+            pyv1(i)=0.
+            pyu1(i)=0.
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=0.
+               ppsrf(i,k)=0.
+            enddo
+         enddo
+
+         dtcum=0.
+      endif
+
+      do k=1,klev
+         do i=1,klon
             mfu(i,k)=mfu(i,k)+pmfu(i,k)*pdtphys
             mfd(i,k)=mfd(i,k)+pmfd(i,k)*pdtphys
@@ -179,4 +399,6 @@
             coefh(i,k)=coefh(i,k)+pcoefh(i,k)*pdtphys
 		t(i,k)=t(i,k)+pt(i,k)*pdtphys
+       fm_therm(i,k)=fm_therm(i,k)+pfm_therm(i,k)*pdtphys
+       entr_therm(i,k)=entr_therm(i,k)+pentr_therm(i,k)*pdtphys
          enddo
       enddo
@@ -193,151 +415,5 @@
 
       dtcum=dtcum+pdtphys
-c
-      IF(mod(iadvtr,istphy).eq.0) THEN
-c
-c   normalisation par le temps cumule
-         do k=1,klev
-            do i=1,klon
-c              frac_impa=frac_impa : c'est la fraction cumulee qu'on stoke
-c              frac_nucl=frac_nucl : c'est la fraction cumulee qu'on stoke
-               mfu(i,k)=mfu(i,k)/dtcum
-               mfd(i,k)=mfd(i,k)/dtcum
-               en_u(i,k)=en_u(i,k)/dtcum
-               de_u(i,k)=de_u(i,k)/dtcum
-               en_d(i,k)=en_d(i,k)/dtcum
-               de_d(i,k)=de_d(i,k)/dtcum
-               coefh(i,k)=coefh(i,k)/dtcum
-		t(i,k)=t(i,k)/dtcum
-            enddo
-         enddo
-         do i=1,klon
-            rain(i)=rain(i)/dtcum
-            pyv1(i)=pyv1(i)/dtcum
-            pyu1(i)=pyu1(i)/dtcum
-         end do
-c modif abderr 23 11 00         do k=1,nbsrf
-             do i=1,klon
-	      do k=1,nbsrf
-               pftsol(i,k)=pftsol(i,k)/dtcum
-	       ppsrf(i,k)=ppsrf(i,k)/dtcum
-	      enddo
-               pftsol1(i) = pftsol(i,1)
-               pftsol2(i) = pftsol(i,2)
-               pftsol3(i) = pftsol(i,3)
-               pftsol4(i) = pftsol(i,4)
-
-c               ppsrf(i,k)=ppsrf(i,k)/dtcum
-               ppsrf1(i) = ppsrf(i,1)
-               ppsrf2(i) = ppsrf(i,2)
-               ppsrf3(i) = ppsrf(i,3)
-               ppsrf4(i) = ppsrf(i,4)
-
-            enddo
-c         enddo
-c
-c   ecriture des champs
-c
-         irec=irec+1
-
-ccccc
-      print*,'AVANT ECRITURE'
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
-         CALL histwrite(physid,"t",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-      print*,'APRES ECRITURE'
-
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
-      CALL histwrite(physid,"mfu",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
-      CALL histwrite(physid,"mfd",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
-      CALL histwrite(physid,"en_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
-      CALL histwrite(physid,"de_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
-      CALL histwrite(physid,"en_d",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)
-      CALL histwrite(physid,"de_d",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)
-      CALL histwrite(physid,"coefh",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-cccc
-       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
-        CALL histwrite(physid,"frac_impa",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex)
-
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
-        CALL histwrite(physid,"frac_nucl",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex)
-
-        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
-      CALL histwrite(physid,"pyu1",itap,zx_tmp_2d,iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
-      CALL histwrite(physid,"pyv1",itap,zx_tmp_2d,iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol1",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-c
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, rain, zx_tmp_2d)
-      CALL histwrite(physid,"rain",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
-      CALL histwrite(physid,"psrf1",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
-      CALL histwrite(physid,"psrf2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
-      CALL histwrite(physid,"psrf3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
-      CALL histwrite(physid,"psrf4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-c
-cAA Test sur la valeur des coefficients de lessivage
-c
-         zmin=1e33
-         zmax=-1e33
-         do k=1,klev
-            do i=1,klon
-                  zmax=max(zmax,frac_nucl(i,k))
-                  zmin=min(zmin,frac_nucl(i,k))
-            enddo
-         enddo
-         Print*,'------ coefs de lessivage (min et max) --------'
-         Print*,'facteur de nucleation ',zmin,zmax
-         zmin=1e33
-         zmax=-1e33
-         do k=1,klev
-            do i=1,klon
-                  zmax=max(zmax,frac_impa(i,k))
-                  zmin=min(zmin,frac_impa(i,k))
-            enddo
-         enddo
-         Print*,'facteur d impaction ',zmin,zmax
-
-      ENDIF
-
+768   continue
 
       RETURN
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phytrac.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/phytrac.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phytrac.F	(revision 633)
@@ -4,7 +4,11 @@
 c
 c
-      SUBROUTINE phytrac (rnpb,nstep,
-     I                    julien,gmtime,
-     I                    debutphy,lafin,
+      SUBROUTINE phytrac (iflag_con,
+     I                    rnpb,
+     I                    nstep,
+     I                    julien,
+     I                    gmtime,
+     I                    debutphy,
+     I                    lafin,
      I                    nqmax,
      I                    nlon,
@@ -23,4 +27,6 @@
      I                    pde_d,
      I                    coefh,
+     I                    fm_therm,
+     I                    entr_therm,
      I                    yu1,
      I                    yv1,
@@ -47,5 +53,10 @@
      I                    prfl,
      I                    psfl,
-#ifdef INCA_CH4
+     I                    da,
+     I                    phi,
+     I                    mp,
+     I                    upwd,
+     I                    dnwd,
+#ifdef INCA
      I                    flxmass_w,
 #endif
@@ -65,7 +76,14 @@
 #ifdef INCA_AER
       USE AEROSOL_MOD, only : ntr,trmx,trnx
-      USE AEROSOL_DIAG, only : cla,las,tausum,angst,aload,scon
-     .                            ,scavcoef_st,scavcoef_cv
-      USE AEROSOL_PROGNOS, ONLY : md
+      USE AEROSOL_DIAG,only : cla,las,tausum,angst,aload,cload,totaerh2o,tau,
+     $  emiss20,sconc,scavcoef_st,scavcoef_cv
+     $  ,cload05ss  ,cload05bc  ,cload05pom  ,cload05dust  ,cload05so4
+     $  ,cload125ss  ,cload125bc  ,cload125pom  ,cload125dust  ,cload125so4
+      USE AEROSOL_PROGNOS, ONLY : md,mdw
+      USE AEROSOL_METEO, only : airm
+#endif
+#ifdef INCA_NMHC
+      USE RESISTANCE_DIAGNOSE, ONLY : surf_alb, sol_irrad, surf_temp, surf_wind,
+     $                                aero_resist, lamin_resist, surf_resist
 #endif
 #endif
@@ -130,11 +148,13 @@
       logical debutphy       ! le flag de l'initialisation de la physique
       logical lafin          ! le flag de la fin de la physique
-
+c Olivia      
+      integer isplit,nsplit
       REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--lessivage convection
       REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--lessivage large-scale
 
-#ifdef INCA_CH4
+#ifdef INCA
       REAL flxmass_w(klon,klev)
 #endif
+      integer iflag_con
 
 cAA Rem : nbtr : nombre de vrais traceurs est defini dans dimphy.h
@@ -146,7 +166,20 @@
       REAL pmfd(nlon,nlev)  ! flux de masse dans le panache descendant
       REAL pen_u(nlon,nlev) ! flux entraine dans le panache montant
+
+c
+c   thermiques:
+c   -----------
+c
+      real fm_therm(klon,klev+1),entr_therm(klon,klev)
+	real fm_therm1(klon,klev)
+c
       REAL pde_u(nlon,nlev) ! flux detraine dans le panache montant
       REAL pen_d(nlon,nlev) ! flux entraine dans le panache descendant
       REAL pde_d(nlon,nlev) ! flux detraine dans le panache descendant
+c KE
+      real da(nlon,nlev),phi(nlon,nlev,nlev),mp(nlon,nlev)
+      REAL upwd(nlon,nlev)      ! saturated updraft mass flux
+      REAL dnwd(nlon,nlev)      ! saturated downdraft mass flux
+
 c
 c   Couche limite:
@@ -264,6 +297,7 @@
 c
       REAL d_tr(klon,klev), d_trs(klon) ! tendances de traceurs 
-      REAL d_tr_cl(klon,klev) ! tendance de traceurs  couche limite
-      REAL d_tr_cv(klon,klev) ! tendance de traceurs  convection 
+      REAL d_tr_cl(klon,klev,nbtr) ! tendance de traceurs  couche limite
+      REAL d_tr_cv(klon,klev,nbtr) ! tendance de traceurs  conv pour chq traceur
+      REAL d_tr_th(klon,klev,nbtr) ! la tendance des thermiques
       REAL d_tr_dec(klon,klev,nbtr) ! la tendance de la decroissance 
 c                                   ! radioactive du rn - > pb 
@@ -280,4 +314,6 @@
       REAL flestottr(klon,klev,nbtr) ! flux de lessivage 
 c                                    ! dans chaque couche 
+      real zmasse(klon,klev)
+      real ztra_th(klon,klev)
 
 C
@@ -288,33 +324,45 @@
 c-------------
       logical first,couchelimite,convection,lessivage,sorties,
-     s        rnpb,inirnpb
-      save first,couchelimite,convection,lessivage,sorties,
-     s     inirnpb
-      data first,couchelimite,convection,lessivage,sorties
-     s     /.true.,.true.,.false.,.true.,.true./
+     s        rnpb,inirnpb,thermiques
+      save first,couchelimite,convection,lessivage,thermiques,
+     s        sorties,inirnpb
+c      data first,couchelimite,convection,lessivage,sorties
+c     s     /.true.,.true.,.false.,.true.,.true./
+c Olivia
+       data first,couchelimite,convection,lessivage,
+     s      thermiques,sorties
+     s     /.true.,.true.,.true.,.true.,.true.,.true./
+
 
 #ifdef INCA
+      INTEGER           :: lastgas
       INTEGER           :: ncsec
+
+      INTEGER           :: prt_flag_ts(nbtr)=(/1,1,1
 #ifdef INCA_CH4
-#ifdef  INCA_AER
-      INTEGER           :: prt_flag_ts(51)=(/1,1,1
-#else
-      INTEGER           :: prt_flag_ts(43)=(/1,1,1
-#endif
-#else
-#ifdef INCA_AER
-      INTEGER           :: prt_flag_ts(11)=(/1,1,1
-#endif
-#endif
-
-#ifdef INCA_CH4
-     .                                              ,1,0,1,1,0,1,0,
-     .                                         0,0,0,0,0,0,0,1,0,0,
+     .                                              ,0,0,1,1,1,1,1,
+     .                                         0,1,0,0,0,0,0,1,0,0,
      .                                         0,1,1,1,1,0,1,1,1,0,
      .                                         1,1,1,1,1,1,1,1,1,1,
      .                                         1,0,0
-#endif
 #ifdef INCA_AER
-     .                                              ,1,1,1,1,1,1,1,1
+     .                                         ,1,1,1,1,0,1,1,1
+#endif
+#endif
+#ifdef INCA_AER
+c aerosol tracers
+     .                                        ,1,0,1,1,1,1,1,1,0,1,
+     .                                         0,1,1,1,1,1,0,1,0,1,1,1
+#endif
+#ifdef INCA_NMHC
+     .                                                 , 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+     .                                          1, 1, 1, 1, 1, 1, 1
 #endif
      .                                         /)
@@ -424,7 +472,10 @@
 
 #ifdef INCA_AER
+
+! Changement Anne 01/04/2005
         CALL aerosolmain (tr_seri,
      $                 pdtphys,
      $                 pplay,
+     $                 pdel,
      $                 prfl,
      $                 pmflxr,
@@ -435,6 +486,11 @@
      $                 ibas_con,
      $                 pphi,
-     $                 airephy,
-     $                 nstep)
+     $                 airephy, ! paire,
+     $                 nstep,
+     $                 rneb,         ! for chimiaq
+     $                 t_seri,       ! for chimiaq
+     $                 rh)
+! fin changement anne
+
 #endif
 
@@ -450,5 +506,6 @@
      $                 pplay,      !pmid
      $                 pdel,       !pdel
-     $                 pctsrf(1,3),!oro
+     $                 airephy,
+     $                 pctsrf(1,1),!oro
      $                 ftsol,      !tsurf
      $                 albsol,     !albs
@@ -485,5 +542,5 @@
 
 c Abder
-      if(nqmax.gt.2) aerosol(3)=.true.
+ctestmaf      if(nqmax.gt.2) aerosol(3)=.true.
 
        do i=1,nlon
@@ -505,8 +562,8 @@
 c======================================================================
 c     print*,'Avant convection'
-      do it=1,nqmax
-         WRITE(itn,'(i2)') it
+c      do it=1,nqmax
+c         WRITE(itn,'(i2)') it
 c        call diagtracphy(tr_seri(:,:,it),paprs,'Avant conv'//itn)
-      enddo
+c      enddo
 
       if (convection) then
@@ -517,12 +574,19 @@
       IF ( conv_flg(it) == 0 ) CYCLE
 #endif
+      if (iflag_con.eq.2) then
+c tiedke
       CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
-     .            pplay, paprs, tr_seri(1,1,it), d_tr_cv)
+     .            pplay, paprs, tr_seri(1,1,it), d_tr_cv(1,1,it))
+      else if (iflag_con.eq.3) then
+c KE
+      call cvltr(pdtphys, da, phi, mp, paprs,pplay, tr_seri(1,1,it),
+     .           upwd,dnwd,d_tr_cv(1,1,it))
+      endif
+
       DO k = 1, nlev
       DO i = 1, klon
-         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cv(i,k)
+         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cv(i,k,it)
       ENDDO
       ENDDO
-c      WRITE(itn,'(i1)') it
 #ifdef INCA
       CALL minmaxqfi(tr_seri(1,1,it),0.,1.e33,'convection it = '
@@ -541,4 +605,63 @@
 c      enddo
 
+
+c======================================================================
+c   Calcul de l'effet des thermiques
+c======================================================================
+
+      do k=1,klev
+         do i=1,klon
+            zmasse(i,k)=(paprs(i,k)-paprs(i,k+1))/rg
+         enddo
+      enddo
+
+c      print*,'masse dans ph ',zmasse
+      do it=1,nqmax
+         do k=1,klev
+            do i=1,klon
+               d_tr_th(i,k,it)=0.
+               tr_seri(i,k,it)=max(tr_seri(i,k,it),0.)
+               tr_seri(i,k,it)=min(tr_seri(i,k,it),1.e10)
+            enddo
+         enddo
+      enddo
+
+      if (thermiques) then
+        print*,'calcul de leffet des thermiques'
+        nsplit=10
+        DO it=1, nqmax
+c        WRITE(itn,'(i1)') it
+c        CALL minmaxqfi(tr_seri(1,1,it),1.e10,-1.e33,'conv it='//itn)
+c	     print*,'avant dqthermiquesretro'
+c             call dump2d(iim,jjm-1,tr_seri(2,1,1),'TR_SERI      ')
+
+         do isplit=1,nsplit
+c  Abderr 25 11 02
+C Thermiques 
+c	print*,'Avant dans phytrac',avant
+            call dqthermcell(klon,klev,pdtphys/nsplit
+     .       ,fm_therm,entr_therm,zmasse
+     .       ,tr_seri(1:klon,1:klev,it),d_tr,ztra_th)
+
+            do k=1,klev
+               do i=1,klon
+                  d_tr(i,k)=pdtphys*d_tr(i,k)/nsplit
+                  d_tr_th(i,k,it)=d_tr_th(i,k,it)+d_tr(i,k)
+                  tr_seri(i,k,it)=max(tr_seri(i,k,it)+d_tr(i,k),0.)
+               enddo
+            enddo
+          enddo ! nsplit
+          print*,'apres thermiques'
+c             call dump2d(iim,jjm-1,d_tr_th(1,1,1),'d_tr_th      ')
+c            do k=1,klev
+c	print*,'d_tr_th(',k,')=',tr_seri(280,k,1)
+c	   enddo
+
+c        WRITE(itn,'(i1)') it
+c        CALL minmaxqfi(tr_seri(1,1,it),1.e10,-1.e33,'therm it='//itn)
+       ENDDO ! it
+       endif ! Thermiques
+c       print*,'ATTENTION: sdans thermniques'
+      
 c======================================================================
 c   Calcul de l'effet de la couche limite
@@ -572,8 +695,8 @@
      e                    tautr(it),vdeptr(it),
      e                    xlat,
-     s                    d_tr_cl,d_trs)
+     s                    d_tr_cl(1,1,it),d_trs)
           DO k = 1, nlev
             DO i = 1, klon
-              tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cl(i,k)
+              tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cl(i,k,it)
             ENDDO
           ENDDO
@@ -604,11 +727,10 @@
      s               tr_seri(1,1,it), source,
      e               paprs, pplay, delp,
-     s               d_tr )
+     s               d_tr_cl(1,1,it))
             DO k = 1, nlev
                DO i = 1, klon
-                  tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k)
+                  tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cl(i,k,it)
                ENDDO
             ENDDO
-Cmaf provisoire suppression des prints
 Cmaf          WRITE(itn,'(i1)') it
 cmaf          CALL minmaxqfi(tr_seri(1,1,it),0.,1.e33,'cltracn it='//itn)
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radlwsw.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/radlwsw.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radlwsw.F	(revision 633)
@@ -166,4 +166,9 @@
       REAL*8 ztopswai(kdlon), zsolswai(kdlon) ! dito, indirect
 cjq-end
+!rv
+      tauae(:,:,:)=0.
+      pizae(:,:,:)=0.
+      cgae(:,:,:)=0.
+!rv
       
 c
@@ -546,6 +551,15 @@
       REAL*8 ZFSUPAI(KDLON,KFLEV+1)
       REAL*8 ZFSDNAI(KDLON,KFLEV+1)
+      logical initialized
       SAVE ZFSUPAD, ZFSDNAD, ZFSUPAI, ZFSDNAI ! aerosol fluxes
+!rv
+      save flag_aer
+      data initialized/.false./
 cjq-end
+      if(.not.initialized) then
+        flag_aer=0.
+        initialized=.TRUE.
+      endif
+!rv
       
 c
